/*
 * board.c
 */

#include	<stdio.h>

/*
 *
 */

#include	"board.h"

/*
 *
 */

/*
 * ֐
 *	get_board_status
 * 
 *	Board board
 *		݂̃Q[{[h
 *	int x
 *		x W ( 0 - BOARD_SIZE )
 *	int y
 *		y W ( 0 - BOARD_SIZE )
 * ߒl
 *	Q[{[h̎w肳ꂽꏊ ( x, y Ŏw ) ̐F ( BLACK, WHITE, EMPTY )
 * @\
 *	Q[{[h̎w肳ꂽꏊ ( x, y Ŏw ) ̐F𓾂
 *
 */

char get_board_status ( Board board, int x, int y ) {
  /*
	܁Ax,y  0`wȂ̂ŁÂ܂܂
	A1`wɂȂ
		return board.info[x-1][y-1]G
	ɂ΂悢
  */

  return board.info[x][y];
}

/*
 * ֐
 *	set_board_status
 * 
 *	Board board
 *		݂̃Q[{[h
 *	int x
 *		x W ( 0 - BOARD_SIZE )
 *	int y
 *		y W ( 0 - BOARD_SIZE )
 *	char hand
 *		w肵ꏊɂF BLACK, WHITE, EMPTY
 * ߒl
 *	ݒ̃Q[{[h
 * @\
 *	Q[{[h̎w肳ꂽꏊ ( x, y Ŏw ) ̐Fw肵Fɂ
 *
 */

Board set_board_status ( Board board, int x, int y, char hand ) {
 
  board.info[x][y] = hand;	/* x,y ̒lύX */

  return board;				/* ύXʂԂ */
}

/*
 * ֐
 *	init_board
 * 
 *	Board board
 *		݂̃Q[{[h
 * ߒl
 *	Ȃ (void)
 * @\
 *	Q[{[hԂɂ
 *
 */

Board init_board ( ) {
  Board board;	/* {[h쐬 */
  int x;
  int y;

  /* ŏɁASẴZ(EMPTY)ɂ */

  for ( y = 0; y < BOARD_SIZE; y++ ) {
    for ( x = 0; x < BOARD_SIZE; x++ ) {
      board = set_board_status ( board, x, y, EMPTY );
    }
  }

  /* Ԃ̎l̃R}u */

  x = BOARD_SIZE/2;
  y = BOARD_SIZE/2;

  board = set_board_status ( board, x-1, y-1, WHITE );
  board = set_board_status ( board, x,   y,   WHITE );
  board = set_board_status ( board, x-1, y,   BLACK );
  board = set_board_status ( board, x,   y-1, BLACK );

  return board;
}

/*
 * ֐
 *	print_board
 * 
 *	Board board
 *		݂̃Q[{[h
 * ߒl
 *	Ȃ (void)
 * @\
 *	Q[{[h\
 */

void print_board ( Board board ) {
  int x;
  int y;

  /* ̍W ( A ` H ) o */

  printf ( "  " );
  for ( x = 0; x < BOARD_SIZE; x++ ) {
    printf ( "| %c", 'A' + x );	/* 'A'+0='A', 'A'+1='B',.. */
  }

  printf ( "|\n" );

  for ( y = 0; y < BOARD_SIZE; y++ ) {
	printf ( "--+--+--+--+--+--+--+--+--+\n" );
    printf ( " %d", y + 1 );
    for ( x = 0; x < BOARD_SIZE; x++ ) {
	  if ( get_board_status ( board, x, y ) == BLACK ) {
		printf ( "|"  );
	  } else if ( get_board_status ( board, x, y ) == WHITE ) {
		printf ( "|"  );
	  } else {
		printf ( "|  "  );
	  }
    }
    printf ( "|\n" );
  }
	printf ( "--+--+--+--+--+--+--+--+--+\n" );
}

/*
 * ֐
 *	z_inner_board
 * 
 *	int z
 *		W ( x, y 킸 )
 * ߒl
 *	͂Ă 1 łȂ 0
 * @\
 *	w肵WA{[hɂ邩ǂ𔻒
 */

int z_inner_board ( int z ) {

  return 0 <= z && z < BOARD_SIZE;
}

/*
 * ֐
 *	x_inner_board
 * 
 *	int x
 *		x W
 * ߒl
 *	͂Ă 1 łȂ 0
 * @\
 *	w肵 x WA{[hɂ邩ǂ𔻒
 */

int x_inner_board ( int x ) {

  return z_inner_board ( x );
}

/*
 * ֐
 *	y_inner_board
 * 
 *	int y
 *		y W
 * ߒl
 *	͂Ă 1 łȂ 0
 * @\
 *	w肵 y WA{[hɂ邩ǂ𔻒
 */

int y_inner_board (int y ) {

  return z_inner_board ( y );
}

/*
 * ֐
 *	inner_board
 * 
 *	int x
 *		x W
 *	int y
 *		y W
 * ߒl
 *	͂Ă 1 łȂ 0
 * @\
 *	w肵W (x, y) A{[hɂ邩ǂ𔻒
 */

int inner_board ( int x, int y ) {

  return x_inner_board ( x ) && y_inner_board ( y );
}

/*
 * ֐
 *	get_oposit_color
 * 
 *	char color
 *		݂̐F
 * ߒl
 *	ΐ푊̐F
 * @\
 *	݂̐FAΐ푊̐Fm 
 */

int get_oposit_color ( int color ) {

  return WHITE + BLACK - color;

}

/*
 *
 */
